import { Elements, Meta, MetaType } from ".";
export declare type XmlParserTsIdRandomizerUpdater = (args: {
    newId: string;
}) => void;
export declare type XmlParserTsIdRandomizerMatcher<M extends Meta> = (args: {
    parentJson: any;
    attr: string;
    metaTypeName: keyof M;
    metaType: MetaType;
}) => [string, XmlParserTsIdRandomizerUpdater] | undefined;
export declare class XmlParserTsIdRandomizer<M extends Meta> {
    private readonly args;
    private readonly updaters;
    private readonly toAttribute;
    private readonly attributed;
    private readonly randomized;
    constructor(args: {
        meta: M;
        elements: Elements;
        newIdGenerator: () => string;
        matchers?: XmlParserTsIdRandomizerMatcher<M>[];
    });
    getOriginalIds(): Set<string>;
    ack<X extends keyof M>({ json, parentJson, type, attr, __$$element, arrayIndex, path, }: {
        json: any | undefined;
        type: X;
        attr: keyof M[X];
        arrayIndex?: number;
        __$$element?: string;
        parentJson?: any;
        path?: string;
    }): XmlParserTsIdRandomizer<M>;
    randomize(args?: {
        skipAlreadyAttributedIds: boolean;
    }): this;
    getAttributed(): Map<string, string>;
    getRandomized(): Map<string, string>;
}
//# sourceMappingURL=idRandomizer.d.ts.map